rascsi(1)

NAME
rascsi - Emulates SCSI devices using the Raspberry Pi GPIO pins

SYNOPSIS
rascsi [-F FOLDER] [-L LOG_LEVEL] [-h] [-n VENDOR:PRODUCT:REVISION] [-p PORT] [-r RESERVED_IDS] [-n TYPE] [-v] [-IDn:[u] FILE] [-HDn[:u] FILE]...

DESCRIPTION
rascsi Emulates SCSI devices using the Raspberry Pi GPIO pins.

In the arguments to RaSCSI, one or more SCSI (-IDn[:u]) or SASI (-HDn[:u]) devices can be specified. The number (n) after the ID or HD identifier specifies the ID number for that device. The optional number (u) specifies the LUN (logical unit) for that device. The default LUN is 0. For SCSI: The ID is limited from 0-7. However, typically SCSI ID 7 is reserved for the "initiator" (the host computer). The LUN is limited from 0-31. Note that SASI is considered rare and only used on very early Sharp X68000 computers.

RaSCSI will determine the type of device based upon the file extension of the FILE argument.
    hdf: SASI Hard Disk image (XM6 SASI HD image - typically only used with X68000)
    hds: SCSI Hard Disk image (generic, non-removable)
    hdr: SCSI Hard Disk image (generic, removable)
    hdn: SCSI Hard Disk image (NEC GENUINE)
    hdi: SCSI Hard Disk image (Anex86 HD image)
    nhd: SCSI Hard Disk image (T98Next HD image)
    hda: SCSI Hard Disk image (APPLE GENUINE - typically used with Mac SCSI emulation)
    mos: SCSI Magneto-optical image (XM6 SCSI MO image - typically only used with X68000)
    iso: SCSI CD-ROM image (ISO 9660 image)

For example, if you want to specify an Apple-compatible HD image on ID 0, you can use the following command:
    sudo rascsi -ID0 /path/to/drive/hdimage.hda Once RaSCSI starts, it will open a socket (default port is 6868) to allow external management commands. If another process is using the rascsi port, RaSCSI will terminate, since it is likely another instance of RaSCSI. Once RaSCSI has initialized, the rasctl utility can be used to send commands. To quit RaSCSI, press Control + C. If it is running in the background, you can kill it using an INT signal.

OPTIONS

-b BLOCK_SIZE
    The optional block size. For SCSI drives 512, 1024, 2048 or 4096 bytes, default size is 512 bytes. For SASI drives 256 or 1024 bytes, default is 256 bytes.

-F FOLDER
    The default folder for image files. For files in this folder no absolute path needs to be specified. The initial default folder is '~/images'.

-L LOG_LEVEL
    The rascsi log level (trace, debug, info, warn, err, critical, off). The default log level is 'info'.

-h  Show a help page.

-n VENDOR:PRODUCT:REVISION
    Set the vendor, product and revision for the device, to be returned with the INQUIRY data. A complete set of name components must be provided. VENDOR may have up to 8, PRODUCT up to 16, REVISION up to 4 characters. Padding with blanks to the maxium length is automatically applied. Once set the name of a device cannot be changed.

-p PORT
    The rascsi server port, default is 6868.

-r RESERVED_IDS
    Comma-separated list of IDs to reserve. -p TYPE The optional case-insensitive device type (SAHD, SCHD, SCRM, SCCD, SCMO, SCBR, SCDP). If no type is specified for devices that support an image file, rascsi tries to derive the type from the file extension.

-v  Display the rascsi version.

-IDn[:u] FILE
    n is the SCSI ID number (0-7). u (0-31) is the optional LUN (logical unit). The default LUN is 0.

    FILE is the name of the image file to use for the SCSI device. For devices that do not support an image file (SCBR, SCDP) a dummy name must be provided.

-HDn[:u] FILE
    n is the SASI ID number (0-15). The effective SASI ID is calculated as n/2, the effective SASI LUN is calculated is the remainder of n/2. Alternatively the n:u syntax can be used, where ns is the SASI ID (0-7) and u the LUN (0-1).

    FILE is the name of the image file to use for the SASI device.

    Note: SASI usage is rare, and is typically limited to early Unix workstations and Sharp X68000 systems.

EXAMPLES
Launch RaSCSI with no emulated drives attached:
   rascsi Launch RaSCSI with an Apple hard drive image as ID 0 and a CD-ROM as ID 2
   rascsi -ID0 /path/to/harddrive.hda -ID2 /path/to/cdimage.iso Launch RaSCSI with a removable SCSI drive image as ID 0 and the raw device file /dev/hdb (e.g. a USB stick) and a DaynaPort network adapter as ID 6:
   rascsi -ID0 -t scrm /dev/hdb -ID6 -t scdp DUMMY_FILENAME To create an empty, 100MB HD image, use the following command:
   dd if=/dev/zero of=/path/to/newimage.hda bs=512 count=204800 In case the fallocate command is available a much faster alternative to the dd command is:
   fallocate -l 104857600 /path/to/newimage.hda

SEE ALSO
rasctl(1), scsimon(1), rasdump(1), sasidump(1)

Full documentation is available at: <https://www.github.com/akuker/RASCSI/wiki/>